import java.awt.image.*;
import java.awt.color.*;
import java.io.*;
import javax.imageio.*;
import javax.swing.JFrame;


public class Demo3 {
    public static void main(String [] args) {

	String filename = "binary_blobs.jpg";
	if (args.length>0) filename = args[0];

	showImage f1 = new showImage(filename);
	f1.setLocation(10,10);
	f1.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	int w = f1.getWidth();
	int h = f1.getHeight();
	int mask[][] = { {-1, 0, 1},{-2, 0, 2},{-1, 0, 1} };
	Convolve c = new Convolve(mask);
	c.setScale(8);
	c.setBipolar(true);
	c.showMatrix(mask,"convolution mask");
	long start = System.nanoTime();
	BufferedImage outp = c.doConvolve(f1.img);

	long etime = System.nanoTime() - start;
	double elapsed_time = 1e-6*(double)etime;
	System.out.format("%nElapsed time %g milliseconds%n",elapsed_time);

	showImage f2 = new showImage(outp,"gray version");
	f2.setLocation(200,10);
	f2.writeImage("filt3","jpg");
		
    }
}
